---
title: Text.splitText()
slug: Web/API/Text/splitText
tags:
  - API
  - DOM
  - Method
  - Text
  - splitText
---
<p>{{APIRef("DOM")}}</p>

<p>The <strong><code>Text.splitText()</code></strong> method breaks the {{domxref("Text")}} node into two nodes at the specified offset, keeping both nodes in the tree as siblings.</p>

<p>After the split, the current node contains all the content up to the specified offset point, and a newly created node of the same type contains the remaining text. The newly created node is returned to the caller. If the original node had a parent, the new node is inserted as the next sibling of the original node. If the offset is equal to the length of the original node, the newly created node has no data.</p>

<p>Separated text nodes can be concatenated using the {{domxref("Node.normalize()")}} method.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>newNode</var> = <var>textNode</var>.splitText(<var>offset</var>)
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>offset</var></code></dt>
 <dd>The index immediately before which to break the text node.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>Returns a newly created {{domxref("Text")}} node that contains the text after the specified offset point.</p>

<h3 id="Exceptions_thrown">Exceptions thrown</h3>

<p>A {{domxref("DOMException")}} with a value of <code>INDEX_SIZE_ERR</code> is thrown if the specified offset is negative or is greater than the number of 16-bit units in the node's text; a {{domxref("DOMException")}} with a value of <code>NO_MODIFICATION_ALLOWED_ERR</code> is thrown if the node is read-only.</p>

<h2 id="Example">Example</h2>

<p>In this example, the text of a {{HTMLElement("p")}} is split into two text nodes, and a {{HTMLElement("u")}} is inserted between them.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;p&gt;foobar&lt;/p&gt;</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js notranslate">const p = document.querySelector('p');

// Get contents of &lt;p&gt; as a text node
const foobar = p.firstChild;

// Split 'foobar' into two text nodes, 'foo' and 'bar',
// and save 'bar' as a const
const bar = foobar.splitText(3);

// Create a &lt;u&gt; element containing ' new content '
const u = document.createElement('u');
u.appendChild(document.createTextNode(' new content '));

// Add &lt;u&gt; before 'bar'
p.insertBefore(u, bar);

// The result is: &lt;p&gt;foo&lt;u&gt; new content &lt;/u&gt;bar&lt;/p&gt;</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample("Example", 700, 70)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-text-splittext', 'Text.splitText')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td>No change from {{SpecName('DOM3 Core')}}.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM3 Core', 'core.html#ID-38853C1D', 'Text.splitText')}}</td>
   <td>{{Spec2('DOM3 Core')}}</td>
   <td>No change from {{SpecName('DOM2 Core')}}.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 Core', 'core.html#ID-38853C1D', 'Text.splitText')}}</td>
   <td>{{Spec2('DOM2 Core')}}</td>
   <td>No change from {{SpecName('DOM1')}}.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM1', 'level-one-core.html#ID-38853C1D', 'Text.splitText')}}</td>
   <td>{{Spec2('DOM1')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Text.splitText")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{domxref("Text")}} interface it belongs to.</li>
 <li>The opposite method: {{domxref("Node.normalize")}}.</li>
</ul>
